
var midMozdevOrgOnCtxMenuEvents = {

  MID_TAB_URL: 'chrome://mid/content/mid.xul?tab',
  retries: 0,
  targetnode: null,
  mid_prefsvc: Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch),

  onLoad: function () {
    document.getElementById('contentAreaContextMenu').addEventListener('popupshowing', function (e) {
      midMozdevOrgOnCtxMenuEvents.showContextMenu(e);
    }, false);
  },
  showContextMenu: function (event) {
    var myitem = document.getElementById('mid-mozdev-org-ctx-menuitm');
    myitem.hidden = false;
    if (gContextMenu) this.targetnode = gContextMenu.target;
    this.retries = 0;
    if (this.isContextEnabled()) {
      myitem.hidden = false;
    } else {
      myitem.hidden = true;
    }
  },
  onMenuItemCommand: function (e) {
    var selText = "oldValue";
    var selText = this.getTextSelected();
    var tab = null;
    tab = this.findMidTab();
    if (tab) {
      var b = gBrowser.getBrowserForTab(tab);
      win = b.contentWindow;
      win.domHelper.inputElement.value = selText;
      win.mid_mud.lookup.lookupWord();
      return;
    }
    const nsIWindowMediator = Components.interfaces.nsIWindowMediator;
    var windowMediator = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
    windowMediator = windowMediator.QueryInterface(nsIWindowMediator);
    var win = windowMediator.getMostRecentWindow('mid:main');
    if (win  && win.domHelper) {
      win.domHelper.inputElement.value = selText;
      win.focus();
      win.mid_mud.lookup.lookupWord();
      return
    }
    var args = {
      search_for: selText,
    };
    args.wrappedJSObject = args;

    var watcher = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
                            .getService(Components.interfaces.nsIWindowWatcher);
    watcher.openWindow(window, "chrome://mid/content/", "_blank", "chrome=yes,resizable=yes,dialog=no,scrollbars=yes", args);

  },
  getTextSelected: function () {
    var selection = '';
    var node = null;
    node = this.targetnode;
    if ((node instanceof HTMLTextAreaElement) || ((node instanceof HTMLInputElement) && (node.type == 'text'))) {
      selection = node.value.substring(node.selectionStart, node.selectionEnd);
    } else {
      selection = content.getSelection().toString();
    }
    return selection;
  },
  isContextEnabled: function () {
    if (this.mid_prefsvc.getPrefType('extensions.mid.menus.sendfromcontext') == this.mid_prefsvc.PREF_BOOL) {
      if (this.mid_prefsvc.getBoolPref('extensions.mid.menus.sendfromcontext')) {
        return true;
      }
    }
    return false;
  },
  findMidTab: function () {
    // Look for an existing tab
    var tab = false;
    var numTabs = gBrowser.browsers.length;
    for (var index = 0; index < numTabs; index++) {
      var currentBrowser = gBrowser.getBrowserAtIndex(index);
      if (this.MID_TAB_URL == currentBrowser.currentURI.spec) {
        tab = (gBrowser.tabs ? gBrowser.tabs : gBrowser.mTabs) [index];
        break;
      }
    }
    return tab;
  }
}

window.addEventListener('load', function (e) {
  midMozdevOrgOnCtxMenuEvents.onLoad(e);
}, false);


// Tools menu
var midMozdevOrgOnToolsMenuEvents = {
  mid_prefsvc: Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch),
  onLoad: function () {
    var ovrmenu = document.getElementById('menu_ToolsPopup') || document.getElementById('taskPopup') // Firefox or Seamonkey
    if (ovrmenu) {
      ovrmenu.addEventListener('popupshowing', function (e) {
        midMozdevOrgOnToolsMenuEvents.showToolsMenu(e);
      }, false);
    }
  },
  showToolsMenu: function (event) {
    var myitem = document.getElementById('mid-mozdev-org-tools-menuitem');
    this.retries = 0;
    if (!this.isToolsMenuEnabled()) {
      myitem.hidden = true;
    } else {
      myitem.hidden = false;
    }
  },
  isToolsMenuEnabled: function () {
    if (this.mid_prefsvc.getPrefType('extensions.mid.menus.startfromtask') == this.mid_prefsvc.PREF_BOOL) {
      if (this.mid_prefsvc.getBoolPref('extensions.mid.menus.startfromtask')) {
        return true;
      }
    }
    return false;
  },
  toMIDWindow: function (event) {
    toOpenWindowByType('mid:main', 'chrome://mid/content/');
  },
  newMIDWindow: function (event) {
    if (event && event.shiftKey) {
      this.newMIDTab()
      return;
    }
    window.open('chrome://mid/content/', '_blank', 'chrome=yes,resizable=yes,scrollbars=yes');
  },
  newMIDTab: function () {
    var prevFunc = XULBrowserWindow.hideChromeForLocation;
    XULBrowserWindow.hideChromeForLocation = function (aLocation) {
      return aLocation == 'chrome://mid/content/mid.xul?tab' || prevFunc.apply(XULBrowserWindow, [
        aLocation
      ]);
    }
    var tab = gBrowser.addTab('chrome://mid/content/mid.xul?tab');
    if (tab && gBrowser.pinTab) gBrowser.pinTab(tab);
  }
}

window.addEventListener('load', function (e) {
  midMozdevOrgOnToolsMenuEvents.onLoad(e);
}, false);
